<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>DepCreation xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../apidocs/org/eclipse/papyrus/designer/deployment/tools/DepCreation.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/*****************************************************************************</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2013 CEA LIST.</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <em class="jxr_javadoccomment"> *  Ansgar Radermacher  ansgar.radermacher@cea.fr</em>
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <em class="jxr_javadoccomment"> *****************************************************************************/</em>
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.deployment.tools;
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  <strong class="jxr_keyword">import</strong> java.util.ArrayList;
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> java.util.Collection;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <strong class="jxr_keyword">import</strong> java.util.HashMap;
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> java.util.Map;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> java.util.Stack;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.ecore.EObject;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.transaction.util.TransactionUtil;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.deployment.profile.Deployment.AutoIndex;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.deployment.profile.Deployment.AutoIndexPerNode;
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.deployment.profile.Deployment.ConfigurationProperty;
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.deployment.profile.Deployment.CopyAttributeValue;
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.deployment.profile.Deployment.DeploymentPlan;
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.base.utils.ApplyProfile;
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.base.utils.CommandSupport;
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.base.utils.StdModelLibs;
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.base.utils.TransformationException;
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.base.utils.TransformationRTException;
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.extensions.IM2MTrafo;
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.extensions.M2MTrafoExt;
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.profile.Transformation.M2MTrafo;
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.profile.Transformation.M2MTrafoChain;
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.uml.tools.utils.StereotypeUtil;
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Class;
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Classifier;
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Enumeration;
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.InstanceSpecification;
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.InstanceValue;
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.LiteralInteger;
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Node;
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Package;
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.PackageableElement;
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Port;
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Property;
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Slot;
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.StructuralFeature;
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Type;
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.UMLPackage;
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.ValueSpecification;
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.util.UMLUtil;
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../org/eclipse/papyrus/designer/deployment/tools/DepCreation.html">DepCreation</a> {
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> Map&lt;Object, Integer&gt; map;
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String valueFor = <span class="jxr_string">"value for "</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  	<em class="jxr_comment">// TODO: why needed?</em>
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String CREATE_CONNECTIONS = <span class="jxr_string">"createConnections"</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  <em class="jxr_javadoccomment">	 * Create a slot and add an instance value associated with a part instance</em>
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  <em class="jxr_javadoccomment">	 * specification.</em>
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  <em class="jxr_javadoccomment">	 * @param is</em>
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  <em class="jxr_javadoccomment">	 *            the instance specification for which a slot should be created</em>
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  <em class="jxr_javadoccomment">	 * @param partIS</em>
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  <em class="jxr_javadoccomment">	 *            the instance specification associated with the slot (to be</em>
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  <em class="jxr_javadoccomment">	 *            precise with slot's instance value)</em>
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  <em class="jxr_javadoccomment">	 * @param part</em>
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  <em class="jxr_javadoccomment">	 *            the part associated with the slot, i.e. its defining feature</em>
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  <em class="jxr_javadoccomment">	 * @return The created slot</em>
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Slot createSlot(InstanceSpecification is, InstanceSpecification partIS, Property part) {
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  		<em class="jxr_comment">// the instance specification of the composite has a slot for each part</em>
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  		<em class="jxr_comment">// and it points</em>
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  		<em class="jxr_comment">// to the instance specification associated with the part.</em>
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  		Slot slot = is.createSlot();
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  		slot.setDefiningFeature(part);
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  		InstanceValue iv = (InstanceValue) slot.createValue(<strong class="jxr_keyword">null</strong>, <strong class="jxr_keyword">null</strong>, UMLPackage.eINSTANCE.getInstanceValue());
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  		iv.setInstance(partIS);
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  		<strong class="jxr_keyword">return</strong> slot;
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  	}
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  <em class="jxr_javadoccomment">	 * Create a Slot and a value for a configuration attribute</em>
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  <em class="jxr_javadoccomment">	 * @param attribute</em>
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Slot createSlotForConfigProp(InstanceSpecification is, Property attribute) {
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  
<a class="jxr_linenumber" name="L100" href="#L100">100</a> 		Slot slot = is.createSlot();
<a class="jxr_linenumber" name="L101" href="#L101">101</a> 		slot.setDefiningFeature(attribute);
<a class="jxr_linenumber" name="L102" href="#L102">102</a> 		<em class="jxr_comment">// For primitive types, the UML type does not provide sufficient information to decide</em>
<a class="jxr_linenumber" name="L103" href="#L103">103</a> 		<em class="jxr_comment">// whether it is a string or a numerical value. In case of the C++ profile, primitive</em>
<a class="jxr_linenumber" name="L104" href="#L104">104</a> 		<em class="jxr_comment">// UML types denote a language specific type, but we want to avoid C++ specific code, if</em>
<a class="jxr_linenumber" name="L105" href="#L105">105</a> 		<em class="jxr_comment">// possible.</em>
<a class="jxr_linenumber" name="L106" href="#L106">106</a> 		<em class="jxr_comment">// =&gt; pragmatic solution: use LiteralString as default, unless a check for some known numerical</em>
<a class="jxr_linenumber" name="L107" href="#L107">107</a> 		<em class="jxr_comment">// primitive types holds (in particular the UML primitive types)</em>
<a class="jxr_linenumber" name="L108" href="#L108">108</a> 		<em class="jxr_comment">// In addition, string values are not automatically quoted, i.e. it is possible to enter e.g.</em>
<a class="jxr_linenumber" name="L109" href="#L109">109</a> 		<em class="jxr_comment">// a float value as a string expression (it also means that a "real" string value must be quoted</em>
<a class="jxr_linenumber" name="L110" href="#L110">110</a> 		<em class="jxr_comment">// by the user).</em>
<a class="jxr_linenumber" name="L111" href="#L111">111</a> 		Type type = attribute.getType();
<a class="jxr_linenumber" name="L112" href="#L112">112</a> 		<strong class="jxr_keyword">if</strong> (type != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L113" href="#L113">113</a> 			String name = type.getName();
<a class="jxr_linenumber" name="L114" href="#L114">114</a> 			String qname = type.getQualifiedName();
<a class="jxr_linenumber" name="L115" href="#L115">115</a> 			<strong class="jxr_keyword">if</strong> (type instanceof Enumeration) {
<a class="jxr_linenumber" name="L116" href="#L116">116</a> 				slot.createValue(valueFor + attribute.getName(), type, UMLPackage.eINSTANCE.getInstanceValue());
<a class="jxr_linenumber" name="L117" href="#L117">117</a> 			} <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (name.equals(<span class="jxr_string">"Integer"</span>) || qname.equals(CORBAtypeNames.Octet) <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L118" href="#L118">118</a> 					|| qname.equals(CORBAtypeNames.Long) || qname.equals(CORBAtypeNames.UnsignedLong) || qname.equals(CORBAtypeNames.Short) || qname.equals(CORBAtypeNames.UnsignedShort)) {
<a class="jxr_linenumber" name="L119" href="#L119">119</a> 				slot.createValue(valueFor + attribute.getName(), type, UMLPackage.eINSTANCE.getLiteralInteger());
<a class="jxr_linenumber" name="L120" href="#L120">120</a> 			} <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (name.equals(<span class="jxr_string">"Boolean"</span>)) { <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L121" href="#L121">121</a> 				slot.createValue(valueFor + attribute.getName(), type, UMLPackage.eINSTANCE.getLiteralBoolean());
<a class="jxr_linenumber" name="L122" href="#L122">122</a> 			} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L123" href="#L123">123</a> 				slot.createValue(valueFor + attribute.getName(), type, UMLPackage.eINSTANCE.getLiteralString());
<a class="jxr_linenumber" name="L124" href="#L124">124</a> 			}
<a class="jxr_linenumber" name="L125" href="#L125">125</a> 		}
<a class="jxr_linenumber" name="L126" href="#L126">126</a> 		<strong class="jxr_keyword">return</strong> slot;
<a class="jxr_linenumber" name="L127" href="#L127">127</a> 	}
<a class="jxr_linenumber" name="L128" href="#L128">128</a> 
<a class="jxr_linenumber" name="L129" href="#L129">129</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L130" href="#L130">130</a> <em class="jxr_javadoccomment">	 * Create a string slot and a value for a configuration attribute</em>
<a class="jxr_linenumber" name="L131" href="#L131">131</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L132" href="#L132">132</a> <em class="jxr_javadoccomment">	 * @param attribute</em>
<a class="jxr_linenumber" name="L133" href="#L133">133</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L134" href="#L134">134</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Slot createStringSlotForConfigProp(InstanceSpecification is, Property attribute) {
<a class="jxr_linenumber" name="L135" href="#L135">135</a> 
<a class="jxr_linenumber" name="L136" href="#L136">136</a> 		Slot slot = is.createSlot();
<a class="jxr_linenumber" name="L137" href="#L137">137</a> 		slot.setDefiningFeature(attribute);
<a class="jxr_linenumber" name="L138" href="#L138">138</a> 		Type type = attribute.getType();
<a class="jxr_linenumber" name="L139" href="#L139">139</a> 		<strong class="jxr_keyword">if</strong> (type != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L140" href="#L140">140</a> 			slot.createValue(valueFor + attribute.getName(), type, UMLPackage.eINSTANCE.getLiteralString());
<a class="jxr_linenumber" name="L141" href="#L141">141</a> 		}
<a class="jxr_linenumber" name="L142" href="#L142">142</a> 		<strong class="jxr_keyword">return</strong> slot;
<a class="jxr_linenumber" name="L143" href="#L143">143</a> 	}
<a class="jxr_linenumber" name="L144" href="#L144">144</a> 
<a class="jxr_linenumber" name="L145" href="#L145">145</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L146" href="#L146">146</a> <em class="jxr_javadoccomment">	 * Create a new deployment plan package that is later filled</em>
<a class="jxr_linenumber" name="L147" href="#L147">147</a> <em class="jxr_javadoccomment">	 * @param parent</em>
<a class="jxr_linenumber" name="L148" href="#L148">148</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L149" href="#L149">149</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L150" href="#L150">150</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Package createDepPlanPkg(Package parent, String name) {
<a class="jxr_linenumber" name="L151" href="#L151">151</a> 		Package cdpPkg = parent.createNestedPackage(name);
<a class="jxr_linenumber" name="L152" href="#L152">152</a> 		EObject cdp = StereotypeUtil.applyApp(cdpPkg, DeploymentPlan.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L153" href="#L153">153</a> 		<strong class="jxr_keyword">if</strong> (cdp == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L154" href="#L154">154</a> 			<em class="jxr_comment">// application failed. Assume that profile application is missing and apply profile</em>
<a class="jxr_linenumber" name="L155" href="#L155">155</a> 			<em class="jxr_comment">// first and then stereotype again</em>
<a class="jxr_linenumber" name="L156" href="#L156">156</a> 			CommandSupport.exec(TransactionUtil.getEditingDomain(cdpPkg), <strong class="jxr_keyword">new</strong> ApplyProfile(cdpPkg, StdModelLibs.DEP_PROFILE_URI));
<a class="jxr_linenumber" name="L157" href="#L157">157</a> 			StereotypeUtil.applyApp(cdpPkg, DeploymentPlan.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L158" href="#L158">158</a> 		}
<a class="jxr_linenumber" name="L159" href="#L159">159</a> 		<strong class="jxr_keyword">return</strong> cdpPkg;
<a class="jxr_linenumber" name="L160" href="#L160">160</a> 	}
<a class="jxr_linenumber" name="L161" href="#L161">161</a> 	
<a class="jxr_linenumber" name="L162" href="#L162">162</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L163" href="#L163">163</a> <em class="jxr_javadoccomment">	 * create a deployment plan, i.e. a set of instances that correspond to an</em>
<a class="jxr_linenumber" name="L164" href="#L164">164</a> <em class="jxr_javadoccomment">	 * implementation which is potentially a composite. In case of the latter,</em>
<a class="jxr_linenumber" name="L165" href="#L165">165</a> <em class="jxr_javadoccomment">	 * this function is called recursively to create deployment plans for the</em>
<a class="jxr_linenumber" name="L166" href="#L166">166</a> <em class="jxr_javadoccomment">	 * parts. Since a composite implementation may optionally specify only the</em>
<a class="jxr_linenumber" name="L167" href="#L167">167</a> <em class="jxr_javadoccomment">	 * type of parts (not the concrete implementation), this function also</em>
<a class="jxr_linenumber" name="L168" href="#L168">168</a> <em class="jxr_javadoccomment">	 * supports that a type is passed. In this case, an implementation is</em>
<a class="jxr_linenumber" name="L169" href="#L169">169</a> <em class="jxr_javadoccomment">	 * automatically assigned.</em>
<a class="jxr_linenumber" name="L170" href="#L170">170</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L171" href="#L171">171</a> <em class="jxr_javadoccomment">	 * @param cdp</em>
<a class="jxr_linenumber" name="L172" href="#L172">172</a> <em class="jxr_javadoccomment">	 *            the deployment plan (package) in which to create instances</em>
<a class="jxr_linenumber" name="L173" href="#L173">173</a> <em class="jxr_javadoccomment">	 * @param typeOrImplem</em>
<a class="jxr_linenumber" name="L174" href="#L174">174</a> <em class="jxr_javadoccomment">	 *            the type</em>
<a class="jxr_linenumber" name="L175" href="#L175">175</a> <em class="jxr_javadoccomment">	 * @param nane</em>
<a class="jxr_linenumber" name="L176" href="#L176">176</a> <em class="jxr_javadoccomment">	 *            the name of the instance</em>
<a class="jxr_linenumber" name="L177" href="#L177">177</a> <em class="jxr_javadoccomment">	 * @param createSlotsForConfigValues</em>
<a class="jxr_linenumber" name="L178" href="#L178">178</a> <em class="jxr_javadoccomment">	 *            if true, create slots for configuration values</em>
<a class="jxr_linenumber" name="L179" href="#L179">179</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L180" href="#L180">180</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> InstanceSpecification createDepPlan(Package cdp, Class typeOrImplem, String name, <strong class="jxr_keyword">boolean</strong> createSlotsForConfigValues) <strong class="jxr_keyword">throws</strong> TransformationException {
<a class="jxr_linenumber" name="L181" href="#L181">181</a> 		<strong class="jxr_keyword">return</strong> createDepPlan(cdp, typeOrImplem, name, createSlotsForConfigValues, <strong class="jxr_keyword">new</strong> Stack&lt;Classifier&gt;());
<a class="jxr_linenumber" name="L182" href="#L182">182</a> 	}
<a class="jxr_linenumber" name="L183" href="#L183">183</a> 
<a class="jxr_linenumber" name="L184" href="#L184">184</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> InstanceSpecification createDepPlan(Package cdp, Class typeOrImplem, String name, <strong class="jxr_keyword">boolean</strong> createSlotsForConfigValues, Stack&lt;Classifier&gt; visitedClassifiers) <strong class="jxr_keyword">throws</strong> TransformationException {
<a class="jxr_linenumber" name="L185" href="#L185">185</a> 		<em class="jxr_comment">// create an instance specification for the composite</em>
<a class="jxr_linenumber" name="L186" href="#L186">186</a> 		<strong class="jxr_keyword">if</strong> (visitedClassifiers.contains(typeOrImplem)) {
<a class="jxr_linenumber" name="L187" href="#L187">187</a> 			String path = <span class="jxr_string">""</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L188" href="#L188">188</a> 			<strong class="jxr_keyword">for</strong> (Classifier cl : visitedClassifiers) {
<a class="jxr_linenumber" name="L189" href="#L189">189</a> 				<strong class="jxr_keyword">if</strong> (path.length() &gt; 0) {
<a class="jxr_linenumber" name="L190" href="#L190">190</a> 					path += <span class="jxr_string">", "</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L191" href="#L191">191</a> 				}
<a class="jxr_linenumber" name="L192" href="#L192">192</a> 				path += cl.getName();
<a class="jxr_linenumber" name="L193" href="#L193">193</a> 			}
<a class="jxr_linenumber" name="L194" href="#L194">194</a> 			path += <span class="jxr_string">", "</span> + typeOrImplem.getName(); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L195" href="#L195">195</a> 			<strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> TransformationException(String.format(Messages.DepCreation_CircularReference, typeOrImplem.getQualifiedName(), path));
<a class="jxr_linenumber" name="L196" href="#L196">196</a> 		}
<a class="jxr_linenumber" name="L197" href="#L197">197</a> 		visitedClassifiers.push(typeOrImplem);
<a class="jxr_linenumber" name="L198" href="#L198">198</a> 
<a class="jxr_linenumber" name="L199" href="#L199">199</a> 		InstanceSpecification is;
<a class="jxr_linenumber" name="L200" href="#L200">200</a> 		<em class="jxr_comment">// treat singleton</em>
<a class="jxr_linenumber" name="L201" href="#L201">201</a> 		<strong class="jxr_keyword">if</strong> (DepUtils.isSingleton(typeOrImplem)) {
<a class="jxr_linenumber" name="L202" href="#L202">202</a> 
<a class="jxr_linenumber" name="L203" href="#L203">203</a> 			<em class="jxr_comment">// use canonical name for singleton instance - lower case for type-name</em>
<a class="jxr_linenumber" name="L204" href="#L204">204</a> 			String instanceName = DeployConstants.singletonPrefix + typeOrImplem.getName().toLowerCase();
<a class="jxr_linenumber" name="L205" href="#L205">205</a> 			PackageableElement pe = cdp.getPackagedElement(instanceName);
<a class="jxr_linenumber" name="L206" href="#L206">206</a> 
<a class="jxr_linenumber" name="L207" href="#L207">207</a> 			<strong class="jxr_keyword">if</strong> (pe == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L208" href="#L208">208</a> 				<em class="jxr_comment">// instance specification for singleton does not exist yet =&gt; create</em>
<a class="jxr_linenumber" name="L209" href="#L209">209</a> 				is = (InstanceSpecification) cdp.createPackagedElement(name, UMLPackage.eINSTANCE.getInstanceSpecification());
<a class="jxr_linenumber" name="L210" href="#L210">210</a> 			} <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (pe instanceof InstanceSpecification) {
<a class="jxr_linenumber" name="L211" href="#L211">211</a> 				<em class="jxr_comment">// exists already, return it without recursing into its sub-specifications</em>
<a class="jxr_linenumber" name="L212" href="#L212">212</a> 				<strong class="jxr_keyword">return</strong> (InstanceSpecification) pe;
<a class="jxr_linenumber" name="L213" href="#L213">213</a> 			} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L214" href="#L214">214</a> 				<em class="jxr_comment">// unlikely case that a packaged element with the name</em>
<a class="jxr_linenumber" name="L215" href="#L215">215</a> 				<em class="jxr_comment">// &lt;singletonISname&gt; exists already, but is not an instance specification</em>
<a class="jxr_linenumber" name="L216" href="#L216">216</a> 				<strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> TransformationException(String.format(Messages.DepCreation_SingletonExistsAlready, name));
<a class="jxr_linenumber" name="L217" href="#L217">217</a> 			}
<a class="jxr_linenumber" name="L218" href="#L218">218</a> 		} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L219" href="#L219">219</a> 			is = (InstanceSpecification) cdp.createPackagedElement(name, UMLPackage.eINSTANCE.getInstanceSpecification());
<a class="jxr_linenumber" name="L220" href="#L220">220</a> 		}
<a class="jxr_linenumber" name="L221" href="#L221">221</a> 
<a class="jxr_linenumber" name="L222" href="#L222">222</a> 		Class implementation = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L223" href="#L223">223</a> 
<a class="jxr_linenumber" name="L224" href="#L224">224</a> 		<em class="jxr_comment">// treat HW architecture or nodes as implementations</em>
<a class="jxr_linenumber" name="L225" href="#L225">225</a> 		<strong class="jxr_keyword">if</strong> (!typeOrImplem.isAbstract() || typeOrImplem instanceof Node) {
<a class="jxr_linenumber" name="L226" href="#L226">226</a> 			<em class="jxr_comment">// implementation is known =&gt; must be able to do this.</em>
<a class="jxr_linenumber" name="L227" href="#L227">227</a> 			<strong class="jxr_keyword">if</strong> (typeOrImplem instanceof Class) {
<a class="jxr_linenumber" name="L228" href="#L228">228</a> 				implementation = typeOrImplem;
<a class="jxr_linenumber" name="L229" href="#L229">229</a> 			}
<a class="jxr_linenumber" name="L230" href="#L230">230</a> 		} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L231" href="#L231">231</a> 			<em class="jxr_comment">// problem? further tree expansion might depend on chosen</em>
<a class="jxr_linenumber" name="L232" href="#L232">232</a> 			<em class="jxr_comment">// implementation)</em>
<a class="jxr_linenumber" name="L233" href="#L233">233</a> 			<em class="jxr_comment">// TODO: don't know node yet =&gt; implementation choice is more</em>
<a class="jxr_linenumber" name="L234" href="#L234">234</a> 			<em class="jxr_comment">// general than necessary</em>
<a class="jxr_linenumber" name="L235" href="#L235">235</a> 			implementation = DepUtils.chooseImplementation(typeOrImplem, <strong class="jxr_keyword">null</strong>, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L236" href="#L236">236</a> 		}
<a class="jxr_linenumber" name="L237" href="#L237">237</a> 
<a class="jxr_linenumber" name="L238" href="#L238">238</a> 		<strong class="jxr_keyword">if</strong> (!(implementation instanceof Class)) {
<a class="jxr_linenumber" name="L239" href="#L239">239</a> 			<strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> TransformationException(String.format(Messages.DepCreation_CannotFindImplementation, name, typeOrImplem.getName()));
<a class="jxr_linenumber" name="L240" href="#L240">240</a> 		}
<a class="jxr_linenumber" name="L241" href="#L241">241</a> 		<em class="jxr_comment">// else implementation is instance of Class (and not null)</em>
<a class="jxr_linenumber" name="L242" href="#L242">242</a> 
<a class="jxr_linenumber" name="L243" href="#L243">243</a> 		is.getClassifiers().add(implementation);
<a class="jxr_linenumber" name="L244" href="#L244">244</a> 		<em class="jxr_comment">// create slots for elements that are not in the current model but will be added by transformations, e.g.</em>
<a class="jxr_linenumber" name="L245" href="#L245">245</a> 		<em class="jxr_comment">// container and connector transformations.</em>
<a class="jxr_linenumber" name="L246" href="#L246">246</a> 		<em class="jxr_comment">// TODO: this is not very clean since the referenced elements are actually not in the model (e.g. the connector is</em>
<a class="jxr_linenumber" name="L247" href="#L247">247</a> 		<em class="jxr_comment">// not yet a part which could referenced as a defining feature of a slot). This might require a different strategy</em>
<a class="jxr_linenumber" name="L248" href="#L248">248</a> 		<em class="jxr_comment">// in which the transformed model is part of the user model and synchronized).</em>
<a class="jxr_linenumber" name="L249" href="#L249">249</a> 		<strong class="jxr_keyword">if</strong> (createSlotsForConfigValues) {
<a class="jxr_linenumber" name="L250" href="#L250">250</a> 			addConfigurationOfAddedElements(cdp, is);
<a class="jxr_linenumber" name="L251" href="#L251">251</a> 		}
<a class="jxr_linenumber" name="L252" href="#L252">252</a> 		<em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="L253" href="#L253">253</a> <em class="jxr_comment">		 * EList&lt;ContainerRule&gt; rules = FCMUtil.getAllContainerRules(implementation);</em>
<a class="jxr_linenumber" name="L254" href="#L254">254</a> <em class="jxr_comment">		 * // create slots for configuration.</em>
<a class="jxr_linenumber" name="L255" href="#L255">255</a> <em class="jxr_comment">		 * for (ContainerRule rule : rules) {</em>
<a class="jxr_linenumber" name="L256" href="#L256">256</a> <em class="jxr_comment">		 * addConfigurationOfContainer(rule, is);</em>
<a class="jxr_linenumber" name="L257" href="#L257">257</a> <em class="jxr_comment">		 * }</em>
<a class="jxr_linenumber" name="L258" href="#L258">258</a> <em class="jxr_comment">		 * }</em>
<a class="jxr_linenumber" name="L259" href="#L259">259</a> <em class="jxr_comment">		 * </em>
<a class="jxr_linenumber" name="L260" href="#L260">260</a> <em class="jxr_comment">		 * for (Connector connector : implementation.getOwnedConnectors()) {</em>
<a class="jxr_linenumber" name="L261" href="#L261">261</a> <em class="jxr_comment">		 * org.eclipse.papyrus.designer.components.FCM.Connector fcmConn = UMLUtil.getStereotypeApplication(connector, org.eclipse.papyrus.designer.components.FCM.Connector.class);</em>
<a class="jxr_linenumber" name="L262" href="#L262">262</a> <em class="jxr_comment">		 * if (fcmConn != null) {</em>
<a class="jxr_linenumber" name="L263" href="#L263">263</a> <em class="jxr_comment">		 * String partName = name + "." + connector.getName(); //$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L264" href="#L264">264</a> <em class="jxr_comment">		 * InteractionComponent connectorComp = fcmConn.getIc();</em>
<a class="jxr_linenumber" name="L265" href="#L265">265</a> <em class="jxr_comment">		 * if (connectorComp != null) {</em>
<a class="jxr_linenumber" name="L266" href="#L266">266</a> <em class="jxr_comment">		 * Class cl = fcmConn.getIc().getBase_Class();</em>
<a class="jxr_linenumber" name="L267" href="#L267">267</a> <em class="jxr_comment">		 * if (cl == null) {</em>
<a class="jxr_linenumber" name="L268" href="#L268">268</a> <em class="jxr_comment">		 * throw new TransformationException(Messages.DepCreation_FCMconnectorWithoutBaseClass);</em>
<a class="jxr_linenumber" name="L269" href="#L269">269</a> <em class="jxr_comment">		 * }</em>
<a class="jxr_linenumber" name="L270" href="#L270">270</a> <em class="jxr_comment">		 * // create sub-instance for connector. It is not possible to</em>
<a class="jxr_linenumber" name="L271" href="#L271">271</a> <em class="jxr_comment">		 * // create a slot in the owning instance specification,</em>
<a class="jxr_linenumber" name="L272" href="#L272">272</a> <em class="jxr_comment">		 * // since the connector cannot be referenced as a defining-feature</em>
<a class="jxr_linenumber" name="L273" href="#L273">273</a> <em class="jxr_comment">		 * createDepPlan(cdp, cl, partName, createSlotsForConfigValues, visitedClassifiers);</em>
<a class="jxr_linenumber" name="L274" href="#L274">274</a> <em class="jxr_comment">		 * }</em>
<a class="jxr_linenumber" name="L275" href="#L275">275</a> <em class="jxr_comment">		 * }</em>
<a class="jxr_linenumber" name="L276" href="#L276">276</a> <em class="jxr_comment">		 * }</em>
<a class="jxr_linenumber" name="L277" href="#L277">277</a> <em class="jxr_comment">		 */</em>
<a class="jxr_linenumber" name="L278" href="#L278">278</a> 
<a class="jxr_linenumber" name="L279" href="#L279">279</a> 		<strong class="jxr_keyword">for</strong> (Property attribute : implementation.getAllAttributes()) {
<a class="jxr_linenumber" name="L280" href="#L280">280</a> 			<em class="jxr_comment">// loop over all attributes (not only parts, since we need to</em>
<a class="jxr_linenumber" name="L281" href="#L281">281</a> 			<em class="jxr_comment">// capture singletons)</em>
<a class="jxr_linenumber" name="L282" href="#L282">282</a> 			<strong class="jxr_keyword">if</strong> (attribute instanceof Port) {
<a class="jxr_linenumber" name="L283" href="#L283">283</a> 				<strong class="jxr_keyword">continue</strong>;
<a class="jxr_linenumber" name="L284" href="#L284">284</a> 			}
<a class="jxr_linenumber" name="L285" href="#L285">285</a> 			Type type = attribute.getType();
<a class="jxr_linenumber" name="L286" href="#L286">286</a> 
<a class="jxr_linenumber" name="L287" href="#L287">287</a> 			<strong class="jxr_keyword">if</strong> (DepUtils.isComposition(attribute)) {
<a class="jxr_linenumber" name="L288" href="#L288">288</a> 				<em class="jxr_comment">// composition, attribute is a part</em>
<a class="jxr_linenumber" name="L289" href="#L289">289</a> 				<strong class="jxr_keyword">if</strong> (type instanceof Class) {
<a class="jxr_linenumber" name="L290" href="#L290">290</a> 					Class cl = (Class) type;
<a class="jxr_linenumber" name="L291" href="#L291">291</a> 
<a class="jxr_linenumber" name="L292" href="#L292">292</a> 					<em class="jxr_comment">// TODO: ad-hoc replication support. Better solution via design patterns</em>
<a class="jxr_linenumber" name="L293" href="#L293">293</a> 					<strong class="jxr_keyword">int</strong> upper = attribute.getUpper();
<a class="jxr_linenumber" name="L294" href="#L294">294</a> 					String infix = <span class="jxr_string">""</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L295" href="#L295">295</a> 
<a class="jxr_linenumber" name="L296" href="#L296">296</a> 					<em class="jxr_comment">// TODO: check validation constraints</em>
<a class="jxr_linenumber" name="L297" href="#L297">297</a> 					<strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">int</strong> i = 0; i &lt; upper; i++) {
<a class="jxr_linenumber" name="L298" href="#L298">298</a> 						String partName = name + <span class="jxr_string">"."</span> + attribute.getName(); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L299" href="#L299">299</a> 						<strong class="jxr_keyword">if</strong> (upper &gt; 1) {
<a class="jxr_linenumber" name="L300" href="#L300">300</a> 							partName += <span class="jxr_string">"_"</span> + infix + i; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L301" href="#L301">301</a> 						}
<a class="jxr_linenumber" name="L302" href="#L302">302</a> 						InstanceSpecification partIS = createDepPlan(cdp, cl, partName, createSlotsForConfigValues, visitedClassifiers);
<a class="jxr_linenumber" name="L303" href="#L303">303</a> 						<em class="jxr_comment">// may not create slot for singleton, since automatically done</em>
<a class="jxr_linenumber" name="L304" href="#L304">304</a> 						<strong class="jxr_keyword">if</strong> (!DepUtils.isSingleton((Class) type)) {
<a class="jxr_linenumber" name="L305" href="#L305">305</a> 							createSlot(is, partIS, attribute);
<a class="jxr_linenumber" name="L306" href="#L306">306</a> 						}
<a class="jxr_linenumber" name="L307" href="#L307">307</a> 					}
<a class="jxr_linenumber" name="L308" href="#L308">308</a> 				} <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (StereotypeUtil.isApplied(attribute, ConfigurationProperty.<strong class="jxr_keyword">class</strong>) &amp;&amp; createSlotsForConfigValues) {
<a class="jxr_linenumber" name="L309" href="#L309">309</a> 					<em class="jxr_comment">// is a configuration property, create slot</em>
<a class="jxr_linenumber" name="L310" href="#L310">310</a> 					<em class="jxr_comment">// TODO: implicit assumption that configuration attributes</em>
<a class="jxr_linenumber" name="L311" href="#L311">311</a> 					<em class="jxr_comment">// are not components</em>
<a class="jxr_linenumber" name="L312" href="#L312">312</a> 					createSlotForConfigProp(is, attribute);
<a class="jxr_linenumber" name="L313" href="#L313">313</a> 				}
<a class="jxr_linenumber" name="L314" href="#L314">314</a> 			} <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (type instanceof Class) {
<a class="jxr_linenumber" name="L315" href="#L315">315</a> 				<em class="jxr_comment">// no composition - only create slot, if a singleton</em>
<a class="jxr_linenumber" name="L316" href="#L316">316</a> 				<em class="jxr_comment">// (otherwise, it's not clear with which instance the slot</em>
<a class="jxr_linenumber" name="L317" href="#L317">317</a> 				<em class="jxr_comment">// should be associated)</em>
<a class="jxr_linenumber" name="L318" href="#L318">318</a> 				<strong class="jxr_keyword">if</strong> (DepUtils.isSingleton((Class) type)) {
<a class="jxr_linenumber" name="L319" href="#L319">319</a> 					<em class="jxr_comment">// is a singleton - exactly one instance exists</em>
<a class="jxr_linenumber" name="L320" href="#L320">320</a> 					<em class="jxr_comment">// recursive call - pass empty name, since name for singletons is re-calculated.</em>
<a class="jxr_linenumber" name="L321" href="#L321">321</a> 					InstanceSpecification singletonIS = createDepPlan(cdp, (Class) type, <span class="jxr_string">""</span>, createSlotsForConfigValues, visitedClassifiers); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L322" href="#L322">322</a> 					createSlot(is, singletonIS, attribute);
<a class="jxr_linenumber" name="L323" href="#L323">323</a> 				}
<a class="jxr_linenumber" name="L324" href="#L324">324</a> 			} <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (type == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L325" href="#L325">325</a> 				<strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> TransformationException(String.format(Messages.DepCreation_TypeInAttributeUndefined, attribute.getName(), implementation.getName()));
<a class="jxr_linenumber" name="L326" href="#L326">326</a> 			}
<a class="jxr_linenumber" name="L327" href="#L327">327</a> 		}
<a class="jxr_linenumber" name="L328" href="#L328">328</a> 		visitedClassifiers.pop();
<a class="jxr_linenumber" name="L329" href="#L329">329</a> 		<strong class="jxr_keyword">return</strong> is;
<a class="jxr_linenumber" name="L330" href="#L330">330</a> 	}
<a class="jxr_linenumber" name="L331" href="#L331">331</a> 
<a class="jxr_linenumber" name="L332" href="#L332">332</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L333" href="#L333">333</a> <em class="jxr_javadoccomment">	 * Create slot for configuration properties that originate from elements that are added</em>
<a class="jxr_linenumber" name="L334" href="#L334">334</a> <em class="jxr_javadoccomment">	 * by M2M transformations. For instance, connector and container related transformations</em>
<a class="jxr_linenumber" name="L335" href="#L335">335</a> <em class="jxr_javadoccomment">	 * might add parts that need a configuration.</em>
<a class="jxr_linenumber" name="L336" href="#L336">336</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L337" href="#L337">337</a> <em class="jxr_javadoccomment">	 * @param aRule</em>
<a class="jxr_linenumber" name="L338" href="#L338">338</a> <em class="jxr_javadoccomment">	 * @param is</em>
<a class="jxr_linenumber" name="L339" href="#L339">339</a> <em class="jxr_javadoccomment">	 * @throws TransformationException</em>
<a class="jxr_linenumber" name="L340" href="#L340">340</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L341" href="#L341">341</a> 	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> addConfigurationOfAddedElements(Package cdp, InstanceSpecification is) <strong class="jxr_keyword">throws</strong> TransformationException {
<a class="jxr_linenumber" name="L342" href="#L342">342</a> 		M2MTrafoChain chain = DepUtils.getTransformationChain(cdp);
<a class="jxr_linenumber" name="L343" href="#L343">343</a> 		<strong class="jxr_keyword">if</strong> (chain != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L344" href="#L344">344</a> 			DeploymentPlan cdpStereo = UMLUtil.getStereotypeApplication(cdp, DeploymentPlan.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L345" href="#L345">345</a> 			<strong class="jxr_keyword">if</strong> (cdpStereo != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L346" href="#L346">346</a> 				<strong class="jxr_keyword">for</strong> (Property m2mTrafoRef : chain.getBase_Class().getAllAttributes()) {
<a class="jxr_linenumber" name="L347" href="#L347">347</a> 					M2MTrafo m2mTrafo = UMLUtil.getStereotypeApplication(m2mTrafoRef.getType(), M2MTrafo.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L348" href="#L348">348</a> 
<a class="jxr_linenumber" name="L349" href="#L349">349</a> 					<strong class="jxr_keyword">if</strong> (m2mTrafo != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L350" href="#L350">350</a> 						IM2MTrafo eTrafo = M2MTrafoExt.getM2MTrafo(m2mTrafo);
<a class="jxr_linenumber" name="L351" href="#L351">351</a> 						<em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="L352" href="#L352">352</a> <em class="jxr_comment">						if (eTrafo instanceof IM2MTrafoAddTypes) {</em>
<a class="jxr_linenumber" name="L353" href="#L353">353</a> <em class="jxr_comment">							EList&lt;Type&gt; addedTypes = ((IM2MTrafoAddTypes) eTrafo).getAddedTypes(m2mTrafo, is);</em>
<a class="jxr_linenumber" name="L354" href="#L354">354</a> <em class="jxr_comment">							for (Type addedType : addedTypes) {</em>
<a class="jxr_linenumber" name="L355" href="#L355">355</a> <em class="jxr_comment">								// TODO: create attribute??</em>
<a class="jxr_linenumber" name="L356" href="#L356">356</a> <em class="jxr_comment">								createSlotForConfigProp(is, null);</em>
<a class="jxr_linenumber" name="L357" href="#L357">357</a> <em class="jxr_comment">							}</em>
<a class="jxr_linenumber" name="L358" href="#L358">358</a> <em class="jxr_comment">						}</em>
<a class="jxr_linenumber" name="L359" href="#L359">359</a> <em class="jxr_comment">						*/</em>
<a class="jxr_linenumber" name="L360" href="#L360">360</a> 					}
<a class="jxr_linenumber" name="L361" href="#L361">361</a> 				}
<a class="jxr_linenumber" name="L362" href="#L362">362</a> 			}
<a class="jxr_linenumber" name="L363" href="#L363">363</a> 		}
<a class="jxr_linenumber" name="L364" href="#L364">364</a> 	}
<a class="jxr_linenumber" name="L365" href="#L365">365</a> 
<a class="jxr_linenumber" name="L366" href="#L366">366</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L367" href="#L367">367</a> <em class="jxr_javadoccomment">	 * create a deployment plan, i.e. a set of instances that correspond to an</em>
<a class="jxr_linenumber" name="L368" href="#L368">368</a> <em class="jxr_javadoccomment">	 * implementation which is potentially a composite. In case of the latter,</em>
<a class="jxr_linenumber" name="L369" href="#L369">369</a> <em class="jxr_javadoccomment">	 * this function is called recursively to create deployment plans for the</em>
<a class="jxr_linenumber" name="L370" href="#L370">370</a> <em class="jxr_javadoccomment">	 * parts. Since a composite implementation may optionally specify only the</em>
<a class="jxr_linenumber" name="L371" href="#L371">371</a> <em class="jxr_javadoccomment">	 * type of parts (not the concrete implementation), this function also</em>
<a class="jxr_linenumber" name="L372" href="#L372">372</a> <em class="jxr_javadoccomment">	 * supports that a type is passed. In this case, an implementation is</em>
<a class="jxr_linenumber" name="L373" href="#L373">373</a> <em class="jxr_javadoccomment">	 * automatically assigned.</em>
<a class="jxr_linenumber" name="L374" href="#L374">374</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L375" href="#L375">375</a> <em class="jxr_javadoccomment">	 * @param cdp</em>
<a class="jxr_linenumber" name="L376" href="#L376">376</a> <em class="jxr_javadoccomment">	 *            the deployment plan (package) in which to create instances</em>
<a class="jxr_linenumber" name="L377" href="#L377">377</a> <em class="jxr_javadoccomment">	 * @param typeOrImplem</em>
<a class="jxr_linenumber" name="L378" href="#L378">378</a> <em class="jxr_javadoccomment">	 *            the type</em>
<a class="jxr_linenumber" name="L379" href="#L379">379</a> <em class="jxr_javadoccomment">	 * @param nane</em>
<a class="jxr_linenumber" name="L380" href="#L380">380</a> <em class="jxr_javadoccomment">	 *            the name of the instance</em>
<a class="jxr_linenumber" name="L381" href="#L381">381</a> <em class="jxr_javadoccomment">	 * @param createSlotsForConfigValues</em>
<a class="jxr_linenumber" name="L382" href="#L382">382</a> <em class="jxr_javadoccomment">	 *            if true, create slots for configuration values</em>
<a class="jxr_linenumber" name="L383" href="#L383">383</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L384" href="#L384">384</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> InstanceSpecification createPlatformInstances(Package platform, Class implementation, String name) <strong class="jxr_keyword">throws</strong> TransformationException {
<a class="jxr_linenumber" name="L385" href="#L385">385</a> 		<em class="jxr_comment">// create an instance specification for the composite</em>
<a class="jxr_linenumber" name="L386" href="#L386">386</a> 		InstanceSpecification is = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L387" href="#L387">387</a> 		is = (InstanceSpecification) platform.createPackagedElement(name, UMLPackage.eINSTANCE.getInstanceSpecification());
<a class="jxr_linenumber" name="L388" href="#L388">388</a> 		is.getClassifiers().add(implementation);
<a class="jxr_linenumber" name="L389" href="#L389">389</a> 
<a class="jxr_linenumber" name="L390" href="#L390">390</a> 		<em class="jxr_comment">// add connector and container implementations</em>
<a class="jxr_linenumber" name="L391" href="#L391">391</a> 
<a class="jxr_linenumber" name="L392" href="#L392">392</a> 		<strong class="jxr_keyword">for</strong> (Property attribute : implementation.getAllAttributes()) {
<a class="jxr_linenumber" name="L393" href="#L393">393</a> 			<em class="jxr_comment">// loop over all attributes (not only parts, since we need to</em>
<a class="jxr_linenumber" name="L394" href="#L394">394</a> 			<em class="jxr_comment">// capture singletons)</em>
<a class="jxr_linenumber" name="L395" href="#L395">395</a> 			<strong class="jxr_keyword">if</strong> (attribute instanceof Port) {
<a class="jxr_linenumber" name="L396" href="#L396">396</a> 				<strong class="jxr_keyword">continue</strong>;
<a class="jxr_linenumber" name="L397" href="#L397">397</a> 			}
<a class="jxr_linenumber" name="L398" href="#L398">398</a> 			Type type = attribute.getType();
<a class="jxr_linenumber" name="L399" href="#L399">399</a> 
<a class="jxr_linenumber" name="L400" href="#L400">400</a> 			<strong class="jxr_keyword">if</strong> (DepUtils.isComposition(attribute)) {
<a class="jxr_linenumber" name="L401" href="#L401">401</a> 				<em class="jxr_comment">// composition, attribute is a part</em>
<a class="jxr_linenumber" name="L402" href="#L402">402</a> 				<strong class="jxr_keyword">if</strong> (type instanceof Class) { <em class="jxr_comment">// should be a node, but do not require it</em>
<a class="jxr_linenumber" name="L403" href="#L403">403</a> 					Class cl = (Class) type;
<a class="jxr_linenumber" name="L404" href="#L404">404</a> 
<a class="jxr_linenumber" name="L405" href="#L405">405</a> 					<strong class="jxr_keyword">int</strong> upper = attribute.getUpper();
<a class="jxr_linenumber" name="L406" href="#L406">406</a> 					String infix = <span class="jxr_string">""</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L407" href="#L407">407</a> 					<em class="jxr_comment">// TODO: check validation constraints</em>
<a class="jxr_linenumber" name="L408" href="#L408">408</a> 					<strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">int</strong> i = 0; i &lt; upper; i++) {
<a class="jxr_linenumber" name="L409" href="#L409">409</a> 						<em class="jxr_comment">// prefix with name, unless null</em>
<a class="jxr_linenumber" name="L410" href="#L410">410</a> 						String partName = (name != <strong class="jxr_keyword">null</strong>) ? name + DeployConstants.SEP_CHAR : <span class="jxr_string">""</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L411" href="#L411">411</a> 						partName += attribute.getName();
<a class="jxr_linenumber" name="L412" href="#L412">412</a> 						<strong class="jxr_keyword">if</strong> (upper &gt; 1) {
<a class="jxr_linenumber" name="L413" href="#L413">413</a> 							partName += <span class="jxr_string">"_"</span> + infix + i; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L414" href="#L414">414</a> 						}
<a class="jxr_linenumber" name="L415" href="#L415">415</a> 						InstanceSpecification partIS = createPlatformInstances(platform, cl, partName);
<a class="jxr_linenumber" name="L416" href="#L416">416</a> 
<a class="jxr_linenumber" name="L417" href="#L417">417</a> 						<strong class="jxr_keyword">if</strong> (is != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L418" href="#L418">418</a> 							createSlot(is, partIS, attribute);
<a class="jxr_linenumber" name="L419" href="#L419">419</a> 						}
<a class="jxr_linenumber" name="L420" href="#L420">420</a> 					}
<a class="jxr_linenumber" name="L421" href="#L421">421</a> 				} <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (StereotypeUtil.isApplied(attribute, ConfigurationProperty.<strong class="jxr_keyword">class</strong>)) {
<a class="jxr_linenumber" name="L422" href="#L422">422</a> 					<em class="jxr_comment">// is a configuration property, create slot</em>
<a class="jxr_linenumber" name="L423" href="#L423">423</a> 					<em class="jxr_comment">// TODO: implicit assumption that configuration attributes</em>
<a class="jxr_linenumber" name="L424" href="#L424">424</a> 					<em class="jxr_comment">// are not components</em>
<a class="jxr_linenumber" name="L425" href="#L425">425</a> 					createSlotForConfigProp(is, attribute);
<a class="jxr_linenumber" name="L426" href="#L426">426</a> 				}
<a class="jxr_linenumber" name="L427" href="#L427">427</a> 			}
<a class="jxr_linenumber" name="L428" href="#L428">428</a> 		}
<a class="jxr_linenumber" name="L429" href="#L429">429</a> 		<strong class="jxr_keyword">return</strong> is;
<a class="jxr_linenumber" name="L430" href="#L430">430</a> 	}
<a class="jxr_linenumber" name="L431" href="#L431">431</a> 
<a class="jxr_linenumber" name="L432" href="#L432">432</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L433" href="#L433">433</a> <em class="jxr_javadoccomment">	 * Initialize the automatic values within a deployment plan - and the update</em>
<a class="jxr_linenumber" name="L434" href="#L434">434</a> <em class="jxr_javadoccomment">	 * eventual copies of these values.</em>
<a class="jxr_linenumber" name="L435" href="#L435">435</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L436" href="#L436">436</a> <em class="jxr_javadoccomment">	 * @param is</em>
<a class="jxr_linenumber" name="L437" href="#L437">437</a> <em class="jxr_javadoccomment">	 *            the main instance of the deployment plan</em>
<a class="jxr_linenumber" name="L438" href="#L438">438</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L439" href="#L439">439</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> initAutoValues(InstanceSpecification is) {
<a class="jxr_linenumber" name="L440" href="#L440">440</a> 		Collection&lt;InstanceSpecification&gt; isList = <strong class="jxr_keyword">new</strong> ArrayList&lt;InstanceSpecification&gt;();
<a class="jxr_linenumber" name="L441" href="#L441">441</a> 		isList.add(is);
<a class="jxr_linenumber" name="L442" href="#L442">442</a> 		initAutoValues(isList);
<a class="jxr_linenumber" name="L443" href="#L443">443</a> 	}
<a class="jxr_linenumber" name="L444" href="#L444">444</a> 
<a class="jxr_linenumber" name="L445" href="#L445">445</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L446" href="#L446">446</a> <em class="jxr_javadoccomment">	 * Initialize the automatic values within a deployment plan - and update</em>
<a class="jxr_linenumber" name="L447" href="#L447">447</a> <em class="jxr_javadoccomment">	 * eventual copies of these values.</em>
<a class="jxr_linenumber" name="L448" href="#L448">448</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L449" href="#L449">449</a> <em class="jxr_javadoccomment">	 * @param isList</em>
<a class="jxr_linenumber" name="L450" href="#L450">450</a> <em class="jxr_javadoccomment">	 *            a list of instance specifications</em>
<a class="jxr_linenumber" name="L451" href="#L451">451</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L452" href="#L452">452</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> initAutoValues(Collection&lt;InstanceSpecification&gt; isList) {
<a class="jxr_linenumber" name="L453" href="#L453">453</a> 		map = <strong class="jxr_keyword">new</strong> HashMap&lt;Object, Integer&gt;();
<a class="jxr_linenumber" name="L454" href="#L454">454</a> 		<strong class="jxr_keyword">for</strong> (InstanceSpecification is : isList) {
<a class="jxr_linenumber" name="L455" href="#L455">455</a> 			initAutoValuesHelper(is);
<a class="jxr_linenumber" name="L456" href="#L456">456</a> 		}
<a class="jxr_linenumber" name="L457" href="#L457">457</a> 		Stack&lt;InstanceSpecification&gt; isStack = <strong class="jxr_keyword">new</strong> Stack&lt;InstanceSpecification&gt;();
<a class="jxr_linenumber" name="L458" href="#L458">458</a> 		<strong class="jxr_keyword">for</strong> (InstanceSpecification is : isList) {
<a class="jxr_linenumber" name="L459" href="#L459">459</a> 			copyAutoValues(isStack, is);
<a class="jxr_linenumber" name="L460" href="#L460">460</a> 		}
<a class="jxr_linenumber" name="L461" href="#L461">461</a> 	}
<a class="jxr_linenumber" name="L462" href="#L462">462</a> 
<a class="jxr_linenumber" name="L463" href="#L463">463</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L464" href="#L464">464</a> <em class="jxr_javadoccomment">	 * Initialize the automatic values within a deployment plan.</em>
<a class="jxr_linenumber" name="L465" href="#L465">465</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L466" href="#L466">466</a> <em class="jxr_javadoccomment">	 * @param is</em>
<a class="jxr_linenumber" name="L467" href="#L467">467</a> <em class="jxr_javadoccomment">	 *            the main instance of the deployment plan</em>
<a class="jxr_linenumber" name="L468" href="#L468">468</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L469" href="#L469">469</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> initAutoValuesHelper(InstanceSpecification is) {
<a class="jxr_linenumber" name="L470" href="#L470">470</a> 		<strong class="jxr_keyword">for</strong> (Slot slot : is.getSlots()) {
<a class="jxr_linenumber" name="L471" href="#L471">471</a> 			StructuralFeature sf = slot.getDefiningFeature();
<a class="jxr_linenumber" name="L472" href="#L472">472</a> 			<strong class="jxr_keyword">if</strong> (sf == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L473" href="#L473">473</a> 				<strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> RuntimeException(String.format(Messages.DepCreation_DefiningFeatureNull, slot.getOwningInstance().getName()));
<a class="jxr_linenumber" name="L474" href="#L474">474</a> 			}
<a class="jxr_linenumber" name="L475" href="#L475">475</a> 			<strong class="jxr_keyword">if</strong> (StereotypeUtil.isApplied(sf, AutoIndex.<strong class="jxr_keyword">class</strong>)) {
<a class="jxr_linenumber" name="L476" href="#L476">476</a> 				Integer value = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L477" href="#L477">477</a> 				Object key;
<a class="jxr_linenumber" name="L478" href="#L478">478</a> 				<strong class="jxr_keyword">if</strong> (StereotypeUtil.isApplied(sf, AutoIndexPerNode.<strong class="jxr_keyword">class</strong>)) {
<a class="jxr_linenumber" name="L479" href="#L479">479</a> 					InstanceSpecification nodeOrThread = AllocUtils.getNode(is);
<a class="jxr_linenumber" name="L480" href="#L480">480</a> 					key = sf.getName() + nodeOrThread.getName();
<a class="jxr_linenumber" name="L481" href="#L481">481</a> 				} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L482" href="#L482">482</a> 					key = sf;
<a class="jxr_linenumber" name="L483" href="#L483">483</a> 				}
<a class="jxr_linenumber" name="L484" href="#L484">484</a> 				<strong class="jxr_keyword">if</strong> (!map.containsKey(key)) {
<a class="jxr_linenumber" name="L485" href="#L485">485</a> 					map.put(key, <strong class="jxr_keyword">new</strong> Integer(0));
<a class="jxr_linenumber" name="L486" href="#L486">486</a> 				}
<a class="jxr_linenumber" name="L487" href="#L487">487</a> 				value = map.get(key);
<a class="jxr_linenumber" name="L488" href="#L488">488</a> 				value++; <em class="jxr_comment">// no need to put incremented value back into map,</em>
<a class="jxr_linenumber" name="L489" href="#L489">489</a> 							<em class="jxr_comment">// since Integer is a reference =&gt; value is updated</em>
<a class="jxr_linenumber" name="L490" href="#L490">490</a> 
<a class="jxr_linenumber" name="L491" href="#L491">491</a> 				<em class="jxr_comment">// create slot and value specification (literal-integer) for the</em>
<a class="jxr_linenumber" name="L492" href="#L492">492</a> 				<em class="jxr_comment">// auto index</em>
<a class="jxr_linenumber" name="L493" href="#L493">493</a> 				LiteralInteger li = (LiteralInteger) slot.createValue(sf.getName() + DeployConstants.AUTO_POSTFIX, sf.getType(), UMLPackage.eINSTANCE.getLiteralInteger());
<a class="jxr_linenumber" name="L494" href="#L494">494</a> 				li.setValue(value);
<a class="jxr_linenumber" name="L495" href="#L495">495</a> 
<a class="jxr_linenumber" name="L496" href="#L496">496</a> 				<em class="jxr_comment">// recursion in case of values that are instance values</em>
<a class="jxr_linenumber" name="L497" href="#L497">497</a> 				<strong class="jxr_keyword">for</strong> (ValueSpecification vs : slot.getValues()) {
<a class="jxr_linenumber" name="L498" href="#L498">498</a> 					<strong class="jxr_keyword">if</strong> (vs instanceof InstanceValue) {
<a class="jxr_linenumber" name="L499" href="#L499">499</a> 						InstanceSpecification subIS = ((InstanceValue) vs).getInstance();
<a class="jxr_linenumber" name="L500" href="#L500">500</a> 						initAutoValues(subIS);
<a class="jxr_linenumber" name="L501" href="#L501">501</a> 					}
<a class="jxr_linenumber" name="L502" href="#L502">502</a> 				}
<a class="jxr_linenumber" name="L503" href="#L503">503</a> 			}
<a class="jxr_linenumber" name="L504" href="#L504">504</a> 		}
<a class="jxr_linenumber" name="L505" href="#L505">505</a> 	}
<a class="jxr_linenumber" name="L506" href="#L506">506</a> 
<a class="jxr_linenumber" name="L507" href="#L507">507</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L508" href="#L508">508</a> <em class="jxr_javadoccomment">	 * Copy automatic values within a deployment plan.</em>
<a class="jxr_linenumber" name="L509" href="#L509">509</a> <em class="jxr_javadoccomment">	 * Attributes can apply the CopyAttributeValue stereotype. The stereotype can point</em>
<a class="jxr_linenumber" name="L510" href="#L510">510</a> <em class="jxr_javadoccomment">	 * to another attribute (source). If the other attribute has a configuration value, it gets</em>
<a class="jxr_linenumber" name="L511" href="#L511">511</a> <em class="jxr_javadoccomment">	 * copied.</em>
<a class="jxr_linenumber" name="L512" href="#L512">512</a> <em class="jxr_javadoccomment">	 * The function takes into account that the source attribute might be in a component that is</em>
<a class="jxr_linenumber" name="L513" href="#L513">513</a> <em class="jxr_javadoccomment">	 * instantiated several times with different configuration values. The attribute that gets the</em>
<a class="jxr_linenumber" name="L514" href="#L514">514</a> <em class="jxr_javadoccomment">	 * copy must use the "nearest" value which means that there must be a common composite that</em>
<a class="jxr_linenumber" name="L515" href="#L515">515</a> <em class="jxr_javadoccomment">	 * contains both attribute (indirectly).</em>
<a class="jxr_linenumber" name="L516" href="#L516">516</a> <em class="jxr_javadoccomment">	 * The main use case is that connector fragments need to have common configuration attributes</em>
<a class="jxr_linenumber" name="L517" href="#L517">517</a> <em class="jxr_javadoccomment">	 * (e-g- server fragment has automatic index value, client fragment needs to copy this value)</em>
<a class="jxr_linenumber" name="L518" href="#L518">518</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L519" href="#L519">519</a> <em class="jxr_javadoccomment">	 * @param is</em>
<a class="jxr_linenumber" name="L520" href="#L520">520</a> <em class="jxr_javadoccomment">	 *            the main instance of the deployment plan</em>
<a class="jxr_linenumber" name="L521" href="#L521">521</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L522" href="#L522">522</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> copyAutoValues(Stack&lt;InstanceSpecification&gt; isStack, InstanceSpecification is) {
<a class="jxr_linenumber" name="L523" href="#L523">523</a> 		isStack.push(is);
<a class="jxr_linenumber" name="L524" href="#L524">524</a> 		<strong class="jxr_keyword">for</strong> (Slot slot : is.getSlots()) {
<a class="jxr_linenumber" name="L525" href="#L525">525</a> 			StructuralFeature sf = slot.getDefiningFeature();
<a class="jxr_linenumber" name="L526" href="#L526">526</a> 			<strong class="jxr_keyword">if</strong> (sf == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L527" href="#L527">527</a> 				<strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> TransformationRTException(is.getName() + <span class="jxr_string">" has a slot without defining feature"</span>); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L528" href="#L528">528</a> 			}
<a class="jxr_linenumber" name="L529" href="#L529">529</a> 			<strong class="jxr_keyword">if</strong> (StereotypeUtil.isApplied(sf, CopyAttributeValue.<strong class="jxr_keyword">class</strong>)) {
<a class="jxr_linenumber" name="L530" href="#L530">530</a> 				CopyAttributeValue cav = UMLUtil.getStereotypeApplication(sf, CopyAttributeValue.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L531" href="#L531">531</a> 				Property source = cav.getSource();
<a class="jxr_linenumber" name="L532" href="#L532">532</a> 				ValueSpecification vs = getNearestValue(isStack, source);
<a class="jxr_linenumber" name="L533" href="#L533">533</a> 				<strong class="jxr_keyword">if</strong> (vs instanceof LiteralInteger) {
<a class="jxr_linenumber" name="L534" href="#L534">534</a> 					LiteralInteger liCopy = (LiteralInteger) slot.createValue(sf.getName() + <span class="jxr_string">"_copy"</span>, sf.getType(), <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L535" href="#L535">535</a> 							UMLPackage.eINSTANCE.getLiteralInteger());
<a class="jxr_linenumber" name="L536" href="#L536">536</a> 					<strong class="jxr_keyword">int</strong> value = ((LiteralInteger) vs).getValue();
<a class="jxr_linenumber" name="L537" href="#L537">537</a> 					liCopy.setValue(value);
<a class="jxr_linenumber" name="L538" href="#L538">538</a> 				}
<a class="jxr_linenumber" name="L539" href="#L539">539</a> 			}
<a class="jxr_linenumber" name="L540" href="#L540">540</a> 
<a class="jxr_linenumber" name="L541" href="#L541">541</a> 			<em class="jxr_comment">// recursion in case of values that are instance values</em>
<a class="jxr_linenumber" name="L542" href="#L542">542</a> 			<strong class="jxr_keyword">for</strong> (ValueSpecification vs : slot.getValues()) {
<a class="jxr_linenumber" name="L543" href="#L543">543</a> 				<strong class="jxr_keyword">if</strong> (vs instanceof InstanceValue) {
<a class="jxr_linenumber" name="L544" href="#L544">544</a> 					InstanceSpecification subIS = ((InstanceValue) vs).getInstance();
<a class="jxr_linenumber" name="L545" href="#L545">545</a> 					<strong class="jxr_keyword">if</strong> (subIS != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L546" href="#L546">546</a> 						copyAutoValues(isStack, subIS);
<a class="jxr_linenumber" name="L547" href="#L547">547</a> 					}
<a class="jxr_linenumber" name="L548" href="#L548">548</a> 				}
<a class="jxr_linenumber" name="L549" href="#L549">549</a> 			}
<a class="jxr_linenumber" name="L550" href="#L550">550</a> 		}
<a class="jxr_linenumber" name="L551" href="#L551">551</a> 		isStack.pop();
<a class="jxr_linenumber" name="L552" href="#L552">552</a> 	}
<a class="jxr_linenumber" name="L553" href="#L553">553</a> 
<a class="jxr_linenumber" name="L554" href="#L554">554</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L555" href="#L555">555</a> <em class="jxr_javadoccomment">	 * try to find a value (ValueSpecification) for the passed source element,</em>
<a class="jxr_linenumber" name="L556" href="#L556">556</a> <em class="jxr_javadoccomment">	 * beginning a the "deepest" instance specification of the passed stack. If</em>
<a class="jxr_linenumber" name="L557" href="#L557">557</a> <em class="jxr_javadoccomment">	 * not found, continue at elements higher up in the hierarchy</em>
<a class="jxr_linenumber" name="L558" href="#L558">558</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L559" href="#L559">559</a> <em class="jxr_javadoccomment">	 * @param isStack</em>
<a class="jxr_linenumber" name="L560" href="#L560">560</a> <em class="jxr_javadoccomment">	 *            a stack of instance specifications corresponding to a path</em>
<a class="jxr_linenumber" name="L561" href="#L561">561</a> <em class="jxr_javadoccomment">	 *            within an instance tree</em>
<a class="jxr_linenumber" name="L562" href="#L562">562</a> <em class="jxr_javadoccomment">	 * @param source</em>
<a class="jxr_linenumber" name="L563" href="#L563">563</a> <em class="jxr_javadoccomment">	 *            a property (defining feature) for which we search an instance</em>
<a class="jxr_linenumber" name="L564" href="#L564">564</a> <em class="jxr_javadoccomment">	 *            specification</em>
<a class="jxr_linenumber" name="L565" href="#L565">565</a> <em class="jxr_javadoccomment">	 * @return The value specifications for the passed source property or null</em>
<a class="jxr_linenumber" name="L566" href="#L566">566</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L567" href="#L567">567</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> ValueSpecification getNearestValue(Stack&lt;InstanceSpecification&gt; isStack, Property source) {
<a class="jxr_linenumber" name="L568" href="#L568">568</a> 		Stack&lt;InstanceSpecification&gt; copy = <strong class="jxr_keyword">new</strong> Stack&lt;InstanceSpecification&gt;();
<a class="jxr_linenumber" name="L569" href="#L569">569</a> 		copy.addAll(isStack);
<a class="jxr_linenumber" name="L570" href="#L570">570</a> 		<strong class="jxr_keyword">while</strong> (!copy.isEmpty()) {
<a class="jxr_linenumber" name="L571" href="#L571">571</a> 			InstanceSpecification pop = copy.pop();
<a class="jxr_linenumber" name="L572" href="#L572">572</a> 			ValueSpecification vs = getNearestValueHelper(isStack, pop, source);
<a class="jxr_linenumber" name="L573" href="#L573">573</a> 			<strong class="jxr_keyword">if</strong> (vs != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L574" href="#L574">574</a> 				<strong class="jxr_keyword">return</strong> vs;
<a class="jxr_linenumber" name="L575" href="#L575">575</a> 			}
<a class="jxr_linenumber" name="L576" href="#L576">576</a> 		}
<a class="jxr_linenumber" name="L577" href="#L577">577</a> 		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L578" href="#L578">578</a> 	}
<a class="jxr_linenumber" name="L579" href="#L579">579</a> 
<a class="jxr_linenumber" name="L580" href="#L580">580</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L581" href="#L581">581</a> <em class="jxr_javadoccomment">	 * Helper for getNearestValue: search for an instance specification that has</em>
<a class="jxr_linenumber" name="L582" href="#L582">582</a> <em class="jxr_javadoccomment">	 * source as defining feature. Start at the passed instance specification,</em>
<a class="jxr_linenumber" name="L583" href="#L583">583</a> <em class="jxr_javadoccomment">	 * but do not recurse into elements that are contained in the stack.</em>
<a class="jxr_linenumber" name="L584" href="#L584">584</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L585" href="#L585">585</a> <em class="jxr_javadoccomment">	 * @param isStack</em>
<a class="jxr_linenumber" name="L586" href="#L586">586</a> <em class="jxr_javadoccomment">	 *            A stack of instance specifications corresponding to a path</em>
<a class="jxr_linenumber" name="L587" href="#L587">587</a> <em class="jxr_javadoccomment">	 *            within an instance tree</em>
<a class="jxr_linenumber" name="L588" href="#L588">588</a> <em class="jxr_javadoccomment">	 * @param is</em>
<a class="jxr_linenumber" name="L589" href="#L589">589</a> <em class="jxr_javadoccomment">	 *            the starting instance specification</em>
<a class="jxr_linenumber" name="L590" href="#L590">590</a> <em class="jxr_javadoccomment">	 * @param source</em>
<a class="jxr_linenumber" name="L591" href="#L591">591</a> <em class="jxr_javadoccomment">	 *            source a property (defining feature) for which we search an</em>
<a class="jxr_linenumber" name="L592" href="#L592">592</a> <em class="jxr_javadoccomment">	 *            instance specification</em>
<a class="jxr_linenumber" name="L593" href="#L593">593</a> <em class="jxr_javadoccomment">	 * @return The value specifications for the passed source property or null</em>
<a class="jxr_linenumber" name="L594" href="#L594">594</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L595" href="#L595">595</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> ValueSpecification getNearestValueHelper(Stack&lt;InstanceSpecification&gt; isStack, InstanceSpecification is, Property source) {
<a class="jxr_linenumber" name="L596" href="#L596">596</a> 		<strong class="jxr_keyword">for</strong> (Slot slot : is.getSlots()) {
<a class="jxr_linenumber" name="L597" href="#L597">597</a> 			StructuralFeature sf = slot.getDefiningFeature();
<a class="jxr_linenumber" name="L598" href="#L598">598</a> 			<strong class="jxr_keyword">if</strong> (sf == source) {
<a class="jxr_linenumber" name="L599" href="#L599">599</a> 				<em class="jxr_comment">// found property, now return first value specification</em>
<a class="jxr_linenumber" name="L600" href="#L600">600</a> 				<strong class="jxr_keyword">for</strong> (ValueSpecification vs : slot.getValues()) {
<a class="jxr_linenumber" name="L601" href="#L601">601</a> 					<strong class="jxr_keyword">return</strong> vs;
<a class="jxr_linenumber" name="L602" href="#L602">602</a> 				}
<a class="jxr_linenumber" name="L603" href="#L603">603</a> 				<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L604" href="#L604">604</a> 			}
<a class="jxr_linenumber" name="L605" href="#L605">605</a> 
<a class="jxr_linenumber" name="L606" href="#L606">606</a> 			<em class="jxr_comment">// recursion in case of values that are instance values</em>
<a class="jxr_linenumber" name="L607" href="#L607">607</a> 			<strong class="jxr_keyword">for</strong> (ValueSpecification vs : slot.getValues()) {
<a class="jxr_linenumber" name="L608" href="#L608">608</a> 				<strong class="jxr_keyword">if</strong> (vs instanceof InstanceValue) {
<a class="jxr_linenumber" name="L609" href="#L609">609</a> 					InstanceSpecification subIS = ((InstanceValue) vs).getInstance();
<a class="jxr_linenumber" name="L610" href="#L610">610</a> 					<strong class="jxr_keyword">if</strong> (!isStack.contains(subIS)) {
<a class="jxr_linenumber" name="L611" href="#L611">611</a> 						<em class="jxr_comment">// only recurse, if not contained in stack of instance</em>
<a class="jxr_linenumber" name="L612" href="#L612">612</a> 						<em class="jxr_comment">// specifications (avoid traversing</em>
<a class="jxr_linenumber" name="L613" href="#L613">613</a> 						<em class="jxr_comment">// the same elements multiple times)</em>
<a class="jxr_linenumber" name="L614" href="#L614">614</a> 						<strong class="jxr_keyword">return</strong> getNearestValueHelper(isStack, subIS, source);
<a class="jxr_linenumber" name="L615" href="#L615">615</a> 					}
<a class="jxr_linenumber" name="L616" href="#L616">616</a> 				}
<a class="jxr_linenumber" name="L617" href="#L617">617</a> 			}
<a class="jxr_linenumber" name="L618" href="#L618">618</a> 		}
<a class="jxr_linenumber" name="L619" href="#L619">619</a> 		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L620" href="#L620">620</a> 	}
<a class="jxr_linenumber" name="L621" href="#L621">621</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016&#x2013;2017 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
